<?php

/**
 * Generate getter/setter/constant from config
 */

$config = include __DIR__ . '/config/metatags.php';

$date = date('Y-m-d H:i:s');

$contract = <<<EOT
<?php

namespace Blok\Metatags\Contracts;

/**
 * MetatagsContract

 * @package Blok\Metatags\Traits
 * @comments Generated by ../../generator.php the $date
 */
interface MetatagsContract
{

EOT;

$output = <<<EOT
<?php

namespace Blok\Metatags\Traits;

/**
 * Trait HasMetatags
 * @package Blok\Metatags\Traits
 * @comments Generated by ../../generator.php the $date
 */
trait HasMetatags
{
    public \$_metatags = [];
EOT;

foreach ($config['meta'] as $key => $value) {
    $normalizedKey = str_replace(' ', '', ucwords(str_replace(['.', ':', '-', '_'], ' ', $key)));
    $contract .= "    public const META_".strtoupper($normalizedKey)." = '".$key."';\n";
    $output .= <<<EOT

    public function getMeta$normalizedKey(){
        return \$this->_metatags['$normalizedKey'] ?? null;
    }

    public function setMeta$normalizedKey(\$value){
        \$this->_metatags['$normalizedKey'] = \$value;
        return \$this;
    }

EOT;
}

$output .= <<<EOT
    /**
     * @param array \$override
     * @return array
     */
    public function getMetatags(\$override = [])
    {
        return \$this->formatMetatags(\$override);
    }

    /**
     * @param array \$override
     * @return array
     */
    public function formatMetatags(\$override = [])
    {
        \$data = [];

        foreach (config('metatags.meta') as \$key => \$meta) {

            \$value = \$this->{'getMeta'.ucfirst(camel_case(str_replace(['.', ':', '-', '_'], ' ', \$key)))}();

            if(!\$value && isset(\$meta['fallback'])){
                foreach(\$meta['fallback'] as \$k){

                    \$value = \$this->{'getMeta'.ucfirst(camel_case(str_replace(['.', ':', '-', '_'], ' ', \$k)))}();

                    if(\$value){
                        break;
                    }
                }
            }

            if(\$value){
                \$data[\$key] = [
                    \$meta['key'] => \$key,
                    \$meta['value'] =>  \$value
                ];
            }
        }

        return array_merge(\$data, \$override);
    }
}
EOT;

$contract .= <<<EOT
    /**
     * @param array \$arr
     * @return array
     */
    public function getMetatags(\$arr = []);
}
EOT;

file_put_contents('src/Contracts/MetatagsContract.php', $contract);
file_put_contents('src/Traits/HasMetatags.php', $output);

echo $output;
